Index: /palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_2d.f90	(revision 3003)
+++ /palm/trunk/SOURCE/data_output_2d.f90	(revision 3004)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! precipitation_rate removed, case prr*_xy removed, to_be_resorted have to point
+! to ql_vp_av and not to ql_vp, allocation checks implemented (averaged data 
+! will be assigned to fill values if no allocation happened so far)   
+! 
+! 2963 2018-04-12 14:47:44Z suehring
 ! Introduce index for vegetation/wall, pavement/green-wall and water/window 
 ! surfaces, for clearer access of surface fraction, albedo, emissivity, etc. .
@@ -211,7 +216,7 @@
     USE arrays_3d,                                                             &
         ONLY:  dzw, e, heatflux_output_conversion, nc, nr, p, pt,              &
-               precipitation_amount, precipitation_rate,                       &
-               prr, q, qc, ql, ql_c, ql_v, ql_vp, qr, rho_ocean, s, sa,        &
-               tend, u, v, vpt, w, zu, zw, waterflux_output_conversion
+               precipitation_amount, prr, q, qc, ql, ql_c, ql_v, ql_vp, qr,    &
+               rho_ocean, s, sa, tend, u, v, vpt, w, zu, zw,                   &
+               waterflux_output_conversion
         
     USE averaging
@@ -241,5 +246,6 @@
         
     USE indices,                                                               &
-        ONLY:  nbgp, nx, nxl, nxr, ny, nyn, nys, nz, nzb, nzt, wall_flags_0
+        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nz,   &
+               nzb, nzt, wall_flags_0
                
     USE kinds
@@ -516,4 +522,8 @@
                    to_be_resorted => e
                 ELSE
+                   IF ( .NOT. ALLOCATED( e_av ) ) THEN
+                      ALLOCATE( e_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      e_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => e_av
                 ENDIF
@@ -524,4 +534,8 @@
                    to_be_resorted => pt
                 ELSE
+                   IF ( .NOT. ALLOCATED( lpt_av ) ) THEN
+                      ALLOCATE( lpt_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      lpt_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => lpt_av
                 ENDIF
@@ -537,4 +551,8 @@
                    ENDDO
                 ELSE
+                   IF ( .NOT. ALLOCATED( lwp_av ) ) THEN
+                      ALLOCATE( lwp_av(nysg:nyng,nxlg:nxrg) )
+                      lwp_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    DO  i = nxl, nxr
                       DO  j = nys, nyn
@@ -551,4 +569,8 @@
                    to_be_resorted => nc
                 ELSE
+                   IF ( .NOT. ALLOCATED( nc_av ) ) THEN
+                      ALLOCATE( nc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      nc_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => nc_av
                 ENDIF
@@ -559,4 +581,8 @@
                    to_be_resorted => nr
                 ELSE
+                   IF ( .NOT. ALLOCATED( nr_av ) ) THEN
+                      ALLOCATE( nr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      nr_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => nr_av
                 ENDIF
@@ -581,4 +607,8 @@
                    ENDDO
                 ELSE
+                   IF ( .NOT. ALLOCATED( ghf_av ) ) THEN
+                      ALLOCATE( ghf_av(nysg:nyng,nxlg:nxrg) )
+                      ghf_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    DO  i = nxl, nxr
                       DO  j = nys, nyn
@@ -610,4 +640,8 @@
                    ENDDO
                 ELSE
+                   IF ( .NOT. ALLOCATED( ol_av ) ) THEN
+                      ALLOCATE( ol_av(nysg:nyng,nxlg:nxrg) )
+                      ol_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    DO  i = nxl, nxr
                       DO  j = nys, nyn
@@ -625,4 +659,8 @@
                    to_be_resorted => p
                 ELSE
+                   IF ( .NOT. ALLOCATED( p_av ) ) THEN
+                      ALLOCATE( p_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      p_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    IF ( psolver /= 'sor' )  CALL exchange_horiz( p_av, nbgp )
                    to_be_resorted => p_av
@@ -647,4 +685,8 @@
                    resorted = .TRUE.
                 ELSE
+                   IF ( .NOT. ALLOCATED( pc_av ) ) THEN
+                      ALLOCATE( pc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      pc_av = REAL( fill_value, KIND = wp )
+                   ENDIF
 !                   CALL exchange_horiz( pc_av, nbgp )
                    to_be_resorted => pc_av
@@ -692,4 +734,8 @@
                    resorted = .TRUE.
                 ELSE
+                   IF ( .NOT. ALLOCATED( pr_av ) ) THEN
+                      ALLOCATE( pr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      pr_av = REAL( fill_value, KIND = wp )
+                   ENDIF
 !                   CALL exchange_horiz( pr_av, nbgp )
                    to_be_resorted => pr_av
@@ -704,24 +750,4 @@
                 ENDDO
                 precipitation_amount = 0.0_wp   ! reset for next integ. interval
-                resorted = .TRUE.
-                two_d = .TRUE.
-                level_z(nzb+1) = zu(nzb+1)
-
-             CASE ( 'prr*_xy' )        ! 2d-array
-                IF ( av == 0 )  THEN
-!                   CALL exchange_horiz_2d( prr(nzb+1,:,:) )
-                   DO  i = nxl, nxr
-                      DO  j = nys, nyn
-                         local_pf(i,j,nzb+1) = prr(nzb+1,j,i) * hyrho(nzb+1)
-                      ENDDO
-                   ENDDO
-                ELSE
-!                   CALL exchange_horiz_2d( prr_av(nzb+1,:,:) )
-                   DO  i = nxl, nxr
-                      DO  j = nys, nyn
-                         local_pf(i,j,nzb+1) = prr_av(nzb+1,j,i) * hyrho(nzb+1)
-                      ENDDO
-                   ENDDO
-                ENDIF
                 resorted = .TRUE.
                 two_d = .TRUE.
@@ -739,4 +765,8 @@
                    ENDDO
                 ELSE
+                   IF ( .NOT. ALLOCATED( prr_av ) ) THEN
+                      ALLOCATE( prr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      prr_av = REAL( fill_value, KIND = wp )
+                   ENDIF
 !                   CALL exchange_horiz( prr_av, nbgp )
                    DO  i = nxl, nxr
@@ -768,4 +798,8 @@
                    ENDIF
                 ELSE
+                   IF ( .NOT. ALLOCATED( pt_av ) ) THEN
+                      ALLOCATE( pt_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      pt_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => pt_av
                 ENDIF
@@ -776,4 +810,8 @@
                    to_be_resorted => q
                 ELSE
+                   IF ( .NOT. ALLOCATED( q_av ) ) THEN
+                      ALLOCATE( q_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      q_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => q_av
                 ENDIF
@@ -784,4 +822,8 @@
                    to_be_resorted => qc
                 ELSE
+                   IF ( .NOT. ALLOCATED( qc_av ) ) THEN
+                      ALLOCATE( qc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      qc_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => qc_av
                 ENDIF
@@ -792,4 +834,8 @@
                    to_be_resorted => ql
                 ELSE
+                   IF ( .NOT. ALLOCATED( ql_av ) ) THEN
+                      ALLOCATE( ql_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      ql_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => ql_av
                 ENDIF
@@ -800,4 +846,8 @@
                    to_be_resorted => ql_c
                 ELSE
+                   IF ( .NOT. ALLOCATED( ql_c_av ) ) THEN
+                      ALLOCATE( ql_c_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      ql_c_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => ql_c_av
                 ENDIF
@@ -808,4 +858,8 @@
                    to_be_resorted => ql_v
                 ELSE
+                   IF ( .NOT. ALLOCATED( ql_v_av ) ) THEN
+                      ALLOCATE( ql_v_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      ql_v_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => ql_v_av
                 ENDIF
@@ -844,6 +898,10 @@
                    resorted = .TRUE.
                 ELSE
+                   IF ( .NOT. ALLOCATED( ql_vp_av ) ) THEN
+                      ALLOCATE( ql_vp_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      ql_vp_av = REAL( fill_value, KIND = wp )
+                   ENDIF
 !                   CALL exchange_horiz( ql_vp_av, nbgp )
-                   to_be_resorted => ql_vp
+                   to_be_resorted => ql_vp_av
                 ENDIF
                 IF ( mode == 'xy' )  level_z = zu
@@ -853,4 +911,8 @@
                    to_be_resorted => qr
                 ELSE
+                   IF ( .NOT. ALLOCATED( qr_av ) ) THEN
+                      ALLOCATE( qr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      qr_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => qr_av
                 ENDIF
@@ -883,4 +945,8 @@
                    ENDDO
                 ELSE
+                   IF ( .NOT. ALLOCATED( qsws_av ) ) THEN
+                      ALLOCATE( qsws_av(nysg:nyng,nxlg:nxrg) )
+                      qsws_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    DO  i = nxl, nxr
                       DO  j = nys, nyn 
@@ -904,4 +970,8 @@
                    resorted = .TRUE.
                 ELSE
+                   IF ( .NOT. ALLOCATED( qv_av ) ) THEN
+                      ALLOCATE( qv_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      qv_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => qv_av
                 ENDIF
@@ -928,4 +998,8 @@
                    ENDDO
                 ELSE
+                   IF ( .NOT. ALLOCATED( r_a_av ) ) THEN
+                      ALLOCATE( r_a_av(nysg:nyng,nxlg:nxrg) )
+                      r_a_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    DO  i = nxl, nxr
                       DO  j = nys, nyn
@@ -942,4 +1016,8 @@
                    to_be_resorted => rho_ocean
                 ELSE
+                   IF ( .NOT. ALLOCATED( rho_ocean_av ) ) THEN
+                      ALLOCATE( rho_ocean_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      rho_ocean_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => rho_ocean_av
                 ENDIF
@@ -949,4 +1027,8 @@
                    to_be_resorted => s
                 ELSE
+                   IF ( .NOT. ALLOCATED( s_av ) ) THEN
+                      ALLOCATE( s_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      s_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => s_av
                 ENDIF
@@ -956,4 +1038,8 @@
                    to_be_resorted => sa
                 ELSE
+                   IF ( .NOT. ALLOCATED( sa_av ) ) THEN
+                      ALLOCATE( sa_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      sa_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => sa_av
                 ENDIF
@@ -985,4 +1071,8 @@
                    ENDDO
                 ELSE
+                   IF ( .NOT. ALLOCATED( shf_av ) ) THEN
+                      ALLOCATE( shf_av(nysg:nyng,nxlg:nxrg) )
+                      shf_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    DO  i = nxl, nxr
                       DO  j = nys, nyn
@@ -1013,4 +1103,8 @@
                    ENDDO
                 ELSE
+                   IF ( .NOT. ALLOCATED( ssws_av ) ) THEN
+                      ALLOCATE( ssws_av(nysg:nyng,nxlg:nxrg) )
+                      ssws_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    DO  i = nxl, nxr
                       DO  j = nys, nyn 
@@ -1041,4 +1135,8 @@
                    ENDDO
                 ELSE
+                   IF ( .NOT. ALLOCATED( ts_av ) ) THEN
+                      ALLOCATE( ts_av(nysg:nyng,nxlg:nxrg) )
+                      ts_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    DO  i = nxl, nxr
                       DO  j = nys, nyn
@@ -1072,4 +1170,8 @@
 
                 ELSE
+                   IF ( .NOT. ALLOCATED( tsurf_av ) ) THEN
+                      ALLOCATE( tsurf_av(nysg:nyng,nxlg:nxrg) )
+                      tsurf_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    DO  i = nxl, nxr
                       DO  j = nys, nyn
@@ -1087,4 +1189,8 @@
                    to_be_resorted => u
                 ELSE
+                   IF ( .NOT. ALLOCATED( u_av ) ) THEN
+                      ALLOCATE( u_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      u_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => u_av
                 ENDIF
@@ -1115,4 +1221,8 @@
                    ENDDO
                 ELSE
+                   IF ( .NOT. ALLOCATED( us_av ) ) THEN
+                      ALLOCATE( us_av(nysg:nyng,nxlg:nxrg) )
+                      us_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    DO  i = nxl, nxr
                       DO  j = nys, nyn
@@ -1130,4 +1240,8 @@
                    to_be_resorted => v
                 ELSE
+                   IF ( .NOT. ALLOCATED( v_av ) ) THEN
+                      ALLOCATE( v_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      v_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => v_av
                 ENDIF
@@ -1144,4 +1258,8 @@
                    to_be_resorted => vpt
                 ELSE
+                   IF ( .NOT. ALLOCATED( vpt_av ) ) THEN
+                      ALLOCATE( vpt_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      vpt_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => vpt_av
                 ENDIF
@@ -1153,4 +1271,8 @@
                    to_be_resorted => w
                 ELSE
+                   IF ( .NOT. ALLOCATED( w_av ) ) THEN
+                      ALLOCATE( w_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                      w_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    to_be_resorted => w_av
                 ENDIF
@@ -1175,4 +1297,8 @@
                    ENDDO
                 ELSE
+                   IF ( .NOT. ALLOCATED( z0_av ) ) THEN
+                      ALLOCATE( z0_av(nysg:nyng,nxlg:nxrg) )
+                      z0_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    DO  i = nxl, nxr
                       DO  j = nys, nyn
@@ -1203,4 +1329,8 @@
                    ENDDO
                 ELSE
+                   IF ( .NOT. ALLOCATED( z0h_av ) ) THEN
+                      ALLOCATE( z0h_av(nysg:nyng,nxlg:nxrg) )
+                      z0h_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    DO  i = nxl, nxr
                       DO  j = nys, nyn
@@ -1231,4 +1361,8 @@
                    ENDDO
                 ELSE
+                   IF ( .NOT. ALLOCATED( z0q_av ) ) THEN
+                      ALLOCATE( z0q_av(nysg:nyng,nxlg:nxrg) )
+                      z0q_av = REAL( fill_value, KIND = wp )
+                   ENDIF
                    DO  i = nxl, nxr
                       DO  j = nys, nyn
Index: /palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_3d.f90	(revision 3003)
+++ /palm/trunk/SOURCE/data_output_3d.f90	(revision 3004)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Allocation checks implemented (averaged data will be assigned to fill values 
+! if no allocation happened so far) 
+! 
+! 2967 2018-04-13 11:22:08Z raasch
 ! bugfix: missing parallel cpp-directives added
 ! 
@@ -214,5 +218,6 @@
         
     USE indices,                                                               &
-        ONLY:  nbgp, nx, nxl, nxr, ny, nyn, nys, nzb, wall_flags_0
+        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nzb,  &
+               nzt, wall_flags_0
         
     USE kinds
@@ -366,4 +371,8 @@
                 to_be_resorted => e
              ELSE
+                IF ( .NOT. ALLOCATED( e_av ) ) THEN
+                   ALLOCATE( e_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   e_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => e_av
              ENDIF
@@ -373,4 +382,8 @@
                 to_be_resorted => pt
              ELSE
+                IF ( .NOT. ALLOCATED( lpt_av ) ) THEN
+                   ALLOCATE( lpt_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   lpt_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => lpt_av
              ENDIF
@@ -380,4 +393,8 @@
                 to_be_resorted => nc
              ELSE
+                IF ( .NOT. ALLOCATED( nc_av ) ) THEN
+                   ALLOCATE( nc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   nc_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => nc_av
              ENDIF
@@ -387,4 +404,8 @@
                 to_be_resorted => nr
              ELSE
+                IF ( .NOT. ALLOCATED( nr_av ) ) THEN
+                   ALLOCATE( nr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   nr_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => nr_av
              ENDIF
@@ -395,4 +416,8 @@
                 to_be_resorted => p
              ELSE
+                IF ( .NOT. ALLOCATED( p_av ) ) THEN
+                   ALLOCATE( p_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   p_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 IF ( psolver /= 'sor' )  CALL exchange_horiz( p_av, nbgp )
                 to_be_resorted => p_av
@@ -415,4 +440,8 @@
                 resorted = .TRUE.
              ELSE
+                IF ( .NOT. ALLOCATED( pc_av ) ) THEN
+                   ALLOCATE( pc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   pc_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => pc_av
              ENDIF
@@ -458,4 +487,8 @@
                 resorted = .TRUE.
              ELSE
+                IF ( .NOT. ALLOCATED( pr_av ) ) THEN
+                   ALLOCATE( pr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   pr_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => pr_av
              ENDIF
@@ -471,4 +504,8 @@
                 ENDDO
              ELSE
+                IF ( .NOT. ALLOCATED( prr_av ) ) THEN
+                   ALLOCATE( prr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   prr_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
@@ -498,4 +535,8 @@
                 ENDIF
              ELSE
+                IF ( .NOT. ALLOCATED( pt_av ) ) THEN
+                   ALLOCATE( pt_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   pt_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => pt_av
              ENDIF
@@ -505,4 +546,8 @@
                 to_be_resorted => q
              ELSE
+                IF ( .NOT. ALLOCATED( q_av ) ) THEN
+                   ALLOCATE( q_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   q_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => q_av
              ENDIF
@@ -512,4 +557,8 @@
                 to_be_resorted => qc
              ELSE
+                IF ( .NOT. ALLOCATED( qc_av ) ) THEN
+                   ALLOCATE( qc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   qc_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => qc_av
              ENDIF
@@ -519,4 +568,8 @@
                 to_be_resorted => ql
              ELSE
+                IF ( .NOT. ALLOCATED( ql_av ) ) THEN
+                   ALLOCATE( ql_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ql_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => ql_av
              ENDIF
@@ -526,4 +579,8 @@
                 to_be_resorted => ql_c
              ELSE
+                IF ( .NOT. ALLOCATED( ql_c_av ) ) THEN
+                   ALLOCATE( ql_c_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ql_c_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => ql_c_av
              ENDIF
@@ -533,4 +590,8 @@
                 to_be_resorted => ql_v
              ELSE
+                IF ( .NOT. ALLOCATED( ql_v_av ) ) THEN
+                   ALLOCATE( ql_v_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ql_v_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => ql_v_av
              ENDIF
@@ -567,4 +628,8 @@
                 resorted = .TRUE.
              ELSE
+                IF ( .NOT. ALLOCATED( ql_vp_av ) ) THEN
+                   ALLOCATE( ql_vp_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ql_vp_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => ql_vp_av
              ENDIF
@@ -574,4 +639,8 @@
                 to_be_resorted => qr
              ELSE
+                IF ( .NOT. ALLOCATED( qr_av ) ) THEN
+                   ALLOCATE( qr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   qr_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => qr_av
              ENDIF
@@ -588,4 +657,8 @@
                 resorted = .TRUE.
              ELSE
+                IF ( .NOT. ALLOCATED( qv_av ) ) THEN
+                   ALLOCATE( qv_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   qv_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => qv_av
              ENDIF
@@ -595,4 +668,8 @@
                 to_be_resorted => rho_ocean
              ELSE
+                IF ( .NOT. ALLOCATED( rho_ocean_av ) ) THEN
+                   ALLOCATE( u_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   u_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => rho_ocean_av
              ENDIF
@@ -602,4 +679,8 @@
                 to_be_resorted => s
              ELSE
+                IF ( .NOT. ALLOCATED( s_av ) ) THEN
+                   ALLOCATE( s_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   s_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => s_av
              ENDIF
@@ -609,4 +690,8 @@
                 to_be_resorted => sa
              ELSE
+                IF ( .NOT. ALLOCATED( sa_av ) ) THEN
+                   ALLOCATE( sa_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   sa_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => sa_av
              ENDIF
@@ -617,4 +702,8 @@
                 to_be_resorted => u
              ELSE
+                IF ( .NOT. ALLOCATED( u_av ) ) THEN
+                   ALLOCATE( u_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   u_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => u_av
              ENDIF
@@ -625,4 +714,8 @@
                 to_be_resorted => v
              ELSE
+                IF ( .NOT. ALLOCATED( v_av ) ) THEN
+                   ALLOCATE( v_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   v_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => v_av
              ENDIF
@@ -632,4 +725,8 @@
                 to_be_resorted => vpt
              ELSE
+                IF ( .NOT. ALLOCATED( vpt_av ) ) THEN
+                   ALLOCATE( vpt_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   vpt_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => vpt_av
              ENDIF
@@ -640,4 +737,8 @@
                 to_be_resorted => w
              ELSE
+                IF ( .NOT. ALLOCATED( w_av ) ) THEN
+                   ALLOCATE( w_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   w_av = REAL( fill_value, KIND = wp )
+                ENDIF
                 to_be_resorted => w_av
              ENDIF
Index: /palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- /palm/trunk/SOURCE/flow_statistics.f90	(revision 3003)
+++ /palm/trunk/SOURCE/flow_statistics.f90	(revision 3004)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Comments related to the calculation of the inversion height expanded
+! 
+! 3003 2018-04-23 10:22:58Z Giersch
 ! The inversion height will not be calcuated before the first timestep in 
 ! case of restarts.
@@ -2007,5 +2010,9 @@
 !--    The corresponding height is assumed as the boundary layer height, if it
 !--    is less than 1.5 times the height where the heat flux becomes negative
-!--    (positive) for the first time.
+!--    (positive) for the first time. Attention: the resolved vertical sensible 
+!--    heat flux (hom(:,1,17,sr) = w*pt*) is not known at the beginning because
+!--    the calculation happens in advec_s_ws which is called after 
+!--    flow_statistics. Therefore z_i is directly taken from restart data at 
+!--    the beginning of restart runs.  
        IF ( TRIM( initializing_actions ) /= 'read_restart_data' .OR.           &
             simulated_time_at_begin /= simulated_time ) THEN
Index: /palm/trunk/SOURCE/gust_mod.f90
===================================================================
--- /palm/trunk/SOURCE/gust_mod.f90	(revision 3003)
+++ /palm/trunk/SOURCE/gust_mod.f90	(revision 3004)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Interfaces concerning data output updated
+! 
+! 
 ! renamed gust_par to gust_parameters
 ! 
@@ -403,4 +406,6 @@
        LOGICAL      ::  two_d !< flag parameter that indicates 2D variables (horizontal cross sections)
 
+       REAL(wp) ::  fill_value = -999.0_wp    !< value for the _FillValue attribute
+
        REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb:nzt+1) ::  local_pf !<
 
@@ -427,4 +432,6 @@
 
        LOGICAL      ::  found !<
+
+       REAL(wp) ::  fill_value = -999.0_wp    !< value for the _FillValue attribute
 
        REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf !<
Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 3003)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 3004)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! precipitation_rate removed
+! 
+! 2995 2018-04-19 12:13:16Z Giersch
 ! CALL radiation_control is not necessary during initialization because 
 ! calculation of radiative fluxes at model start is done in radiation_init 
@@ -724,6 +727,5 @@
 !
 !--          Precipitation amount and rate (only needed if output is switched)
-             ALLOCATE( precipitation_amount(nysg:nyng,nxlg:nxrg),              &
-                       precipitation_rate(nysg:nyng,nxlg:nxrg) )
+             ALLOCATE( precipitation_amount(nysg:nyng,nxlg:nxrg) )
 
 !
